// model.h

#import "mravec.h"
#import "feromon.h"

#import <objectbase/Swarm.h>
#import <space.h>

@interface Model: Swarm
{
  int worldXSize, worldYSize;
  float seedProb;
  int kolkoMravcov;
  FeromonSpace *feromon;
  id <Grid2d> world;
 
  id mravecList;
  id modelActions;
  id modelSchedule;
}

-getWorld;
-getFeromon;
-getMravecList;

+createBegin: aZone;
-createEnd;
-buildObjects;
-buildActions;
-activateIn: swarmContext;

@end;