// mravec.m

#import "mravec.h"
#import <random.h>

@implementation Mravec
- setWorld: w Feromon: f
{
   world = w;
   feromon = f;

   return self;
}

- createEnd
{
   [super createEnd];

   worldXSize = [world getSizeX];
   worldYSize = [world getSizeY];

   return self;
}

- setX: (int)x Y: (int)y S:(int)s 
{

  xPos = x;
  yPos = y;
  smer = s;

  return self;
}


- setRet:(char *)r 
{
  gen = r;
  dlzka=0;
  while(gen[dlzka]!='\0')
    dlzka++;

  return self;
}


- step
{
  int newX, newY;
  int dx,dy;
  int stopa;

  dlzka=0;
    while(gen[dlzka]!='\0')
      dlzka++;

  if (smer==0) {dx=0;dy=-1;}  
  if (smer==1) {dx=1;dy=0;}  
  if (smer==2) {dx=0;dy=1;}  
  if (smer==3) {dx=-1;dy=0;}  


  newX = xPos + dx;
  newY = yPos + dy;


  newX = (newX + worldXSize) % worldXSize;
  newY = (newY + worldYSize) % worldYSize;

// na jednej bunke len jeden mravec !
//  if ([world getObjectAtX: newX Y: newY] == nil)
//    {
      [world putObject: nil atX: xPos Y: yPos];
      xPos = newX;
      yPos = newY;
      [world putObject: self atX: newX Y: newY];
//    }

// mozog mravca:  tykadlo -> pravidlo -> akcia  

  stopa = [feromon getValueAtX: xPos Y: yPos];

if ( gen[stopa] == 'L' || gen[stopa] == 'l')
    {
      smer=(smer+1)%4;
    }
  else if ( gen[stopa] == 'R' || gen[stopa] == 'r')
    {
      smer=(4+smer-1)%4;
    }

  else if ( gen[stopa] == 'B' || gen[stopa] == 'b')
    {
      smer=(smer+2)%4;
    }
  else if ( gen[stopa] == 'F' || gen[stopa] == 'f')
    {
      smer=smer;
    }


  
  stopa = ( stopa +1 ) % dlzka ;
  [feromon putValue: stopa atX: xPos Y: yPos];

  return self;
}

- drawSelfOn: (id <Raster>)r
{
  [r drawPointX: xPos Y: yPos Color: 9];

  return self;
}
  
@end