//  laboratorium.h

#import "model.h"
#import <simtoolsgui/GUISwarm.h>

@interface Laboratorium: GUISwarm
{
  int displayFrequency;
  
  id displayActions;
  id displaySchedule;

  Model *model; 

  id <Colormap> colorMap;
  id <ZoomRaster> worldRaster;

  id <Value2dDisplay> feromonDisplay;
  id <Object2dDisplay> mravecDisplay;
}

 +createBegin: aZone;
 -createEnd;
 -buildObjects;
 -buildActions;
 -activateIn: swarmContext;

@end